/*
        katemessageview.cpp
        Simple message view for kate plugins
        Copyright (C) 2002 by Anders Lund <anders@alweb.dk>

        $Id: katemessageview.cpp,v 1.2 2002/07/23 21:01:03 alund Exp $
        ---

        This program is free software; you can redistribute it and/or
        modify it under the terms of the GNU General Public License
        as published by the Free Software Foundation; either version 2
        of the License, or (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "katemessageview.h"
#include "katemessageview.moc"

#include <qtextbrowser.h>

KateMessageView::KateMessageView( QWidget *parent, const char *name )
  : KateDockViewBase( parent, name )
{
  m_view = new QTextBrowser( this );
  // m_view->setFormat( Qt::richText ); // should be!!
  connect( m_view, SIGNAL( linkClicked( const QString & ) ), 
           SIGNAL( linkClicked( const QString & ) ) );
}

KateMessageView::~KateMessageView()
{
}

void KateMessageView::addMessage( const QString &msg )
{
  m_view->append( msg );
  m_view->scrollToBottom();
}

void KateMessageView::clear()
{
  m_view->clear();
}
